(****************************************************************************)
(* Illusion BBS - Mail functions [2/?]                                      *)
(****************************************************************************)

Unit Mail2;

{$I MKB.Def}

Interface

Uses CRT, DOS, Mail0, Common,
     MkGlobT, MkMsgAbs, MkString;

Procedure MBaseList;
Procedure MBaseChange(VAR Done:boolean; mStr:astr);
Procedure ConfigZscan;
Procedure LoadMsgZscan;
Procedure SaveMsgZscan;

Implementation

Procedure MBaseList;
Var abort,next:boolean;
    currec,numrec,curalias,rb:word;
    acc       :boolean;  { Access to base? }
    s         :string;
    t         :BaseTyp;  { Base types }
    Half      :Byte;     { First or second half of line? }
    Split     :Byte;     { Middle of screen }
    OldBoardLoaded:Word;

Begin
  abort:=FALSE; next:=FALSE;
  OldBoardLoaded:=BoardLoaded;
  Currec:=0; rb:=0;

  SetFileAccess(ReadOnly, DenyNone);
  Reset(bf);
  NumRec:=FileSize(bf);
  Close(bf);

  spstr(708); {msg base list header}

  Half:=0;
  Split:=ThisUser.LineLen div 2;

  if (numrec=0) then
  begin
    spstr(709); {no msg bases}
    exit;
  end;

  while ((currec<numrec) and (not abort)) do
    begin
      if LoadBoard(currec) then;

      acc:=aacs(Memboard.acs);

      if ((mbvisible in memboard.mbstat) or (acc)) then
        begin
          if (acc) then
            begin
              s:='|W'+mrn(cstr(rb),4)+' ';

              LoadMsgZscan;
              if (msgzscan.qwkscan) then s:=s+'Q' else s:=s+'-';
              if (msgzscan.mailscan) then s:=s+'*' else s:=s+'-';
              s:=s+' ';
              for t:=Public to News do
                begin
                  if t in MemBoard.BaseStat then
                    case t of
                      Public   : s:=s+'P';
                      Private  : s:=s+'R';
                      Networked: s:=s+'N';
                      News     : s:=s+'A';
                    end
                  else
                    s:=s+'-';
                end;
              inc(rb);
              s:=s+' ';
            end
          else
            s:='             ';

          s:=s+'|w'+memboard.name;

          inc(Half);
          if (Half=1) then
            begin
              if (lenn(s)<=Split) then
                s:=mln(s,Split);
              sprompt(s);
              if (lenn(s)>Split) then
                begin
                  nl; Half:=0;
                end;
            end
          else {Half=2}
            begin
              if (lenn(s)>=Split) then nl;
              Sprint(s);
              Half:=0;
            end;

          if (not empty) then wkey(abort,next);
        end;
      inc(currec);
    end; {While}

  if (Half=1) then nl;
  LoadBoard(OldBoardLoaded);
end; {proc MBaseList}

Procedure MBaseChange(VAR Done:boolean; mStr:astr);
var s:astr;
    i:integer;
begin
  if mstr<>'' then
    case mstr[1] of
      '+':begin
            i:=board;
            if (board>=numboards) then i:=0 else
              repeat
                inc(i);
                changeboard(i);
              until (board=i) or (i>numboards);
            if (board<>i) then spstr(735) {highest}
              else lastcommandovr:=TRUE;
          end;
      '-':begin
            i:=board;
            if board<=0 then i:=numboards else
              repeat
                dec(i);
                changeboard(i);
              until (board=i) or (i<=0);
            if (board<>i) then spstr(710)
              else lastcommandovr:=TRUE;
          end;
      'L':mbaselist;
    else
          begin
            changeboard(value(mstr));
            if pos(';',mstr)>0 then begin
              s:=copy(mstr,pos(';',mstr)+1,length(mstr));
              curmenu:=systat.menupath+s+'.mnu';
              newmenutoload:=TRUE;
              done:=TRUE;
            end;
            lastcommandovr:=TRUE;
          end;
    end
  else begin
    if (novice in thisuser.ac) then mbaselist;
    nl;
    s:='?';
    repeat
      spstr(84); {change msg area prompt}
      input(s,3); i:=value(s);
      if s='?' then begin mbaselist; nl; end else
        if (i>=0) and (i<=numboards) and (i<>board) then
          changeboard(i);
    until (s<>'?') or (hangup);
    lastcommandovr:=TRUE;
  end;
end;

Procedure LoadMsgZscan;
var i:word;
begin
  SetFileAccess(ReadWrite,DenyNone);
  assign(msgzscanf,systat.datapath+cstr(memboard.permindx)+'.MSI');
  {$I-} reset(msgzscanf); {$I+}
  if (ioresult=0) then begin
    if (usernum>filesize(msgzscanf)-1) then begin
      seek(msgzscanf,filesize(msgzscanf));
      msgzscan.mailscan := not (MemBoard.ScanType=1);
      msgzscan.qwkscan  := not (MemBoard.ScanType=1);
      for i:=filesize(msgzscanf) to usernum do
        write(msgzscanf,msgzscan);
    end;
    seek(msgzscanf,usernum);
    read(msgzscanf,msgzscan);
    close(msgzscanf);
  end else begin
    rewrite(msgzscanf);
    msgzscan.mailscan := not (MemBoard.ScanType=1);
    msgzscan.qwkscan  := not (MemBoard.ScanType=1);
    for i:=0 to systat.numusers do
      write(msgzscanf,msgzscan);
    seek(msgzscanf,usernum);
    read(msgzscanf,msgzscan);
    close(msgzscanf);
  end;
end;

Procedure SaveMsgZscan;
begin
  SetFileAccess(ReadWrite,DenyNone);
  assign(msgzscanf,systat.datapath+cstr(memboard.permindx)+'.MSI');
  reset(msgzscanf);
  seek(msgzscanf,usernum);
  write(msgzscanf,msgzscan);
  close(msgzscanf);
end;

Procedure ConfigZscan;
var os,s:string;
    i,j,k:word;
    tq,tn,done:boolean;

  Procedure Toggle(base:word);
  Var i:word;
  begin
    i:=RealMsgIdx(base);
    if (i>0) and (i<=numboards) then
    begin
      LoadBoard(i);

      clearwaves;
      addwave('MN',memboard.name,txt);
      if (memboard.scantype=2) then
        spstr(711) {mandatory}
      else
      begin
        LoadMsgZscan;
        if (tn) then
        begin
          msgzscan.mailscan:=not msgzscan.mailscan;
          if (msgzscan.mailscan) then spstr(712) else spstr(713); {scanned/not}
        end;
        if (tq) then
        begin
          msgzscan.qwkscan:=not msgzscan.qwkscan;
          if (msgzscan.qwkscan) then spstr(714) else spstr(715); {scanned/not}
        end;
        SaveMsgZscan;
      end;
      clearwaves;
    end;
  end;

begin
  MBaseList;
  done:=FALSE;
  tn:=true;
  tq:=false;
  repeat
    clearwaves;
    if (tn) and (not tq) then addwave('SF',getstr(716),txt) else {normal}
    if (not tn) and (tq) then addwave('SF',getstr(717),txt) else {qwk}
    if (tn) and (tq)     then addwave('SF',getstr(718),txt);     {norm&qwk}
    spstr(719); {[t]oggling...}
    clearwaves;
    spstr(720); {prompt}
    mpl(8);
    input(s,8);
    s:=sqoutsp(s);
    if (s='Q') then
      done:=TRUE
    else
    if (s='?') then
      mbaselist
    else
    if (s='T') then
    begin
      if (tn and tq) then
        tq:=false
      else
      if (tn and (not tq)) then
      begin
        tq:=true;
        tn:=false;
      end else
        tn:=true;
    end else
    begin
      os:='';
      nl;
      while (s<>'') do
      begin
        j:=pos(',',s);
        if (j=0) then
        begin
          os:=s;
          s:='';
        end else
        begin
          os:=copy(s,1,j-1);
          delete(s,1,j);
        end;
        j:=pos('-',os);
        if (j=0) then
        begin
          i:=value(os);
          if (i>0) then
            toggle(i);
        end else
        begin
          i:=value(copy(os,1,j-1));
          k:=value(copy(os,j+1,length(os)-j));
          if (i>0) and (k>0) then
          begin
            if (i>k) then {swap them}
            begin
              j:=k;
              k:=i;
              i:=j;
            end;
            for j:=i to k do
              toggle(j);
          end;
        end;
      end;
    end;
  until (done) or (hangup);
  lastcommandovr:=TRUE;
end;

End.
